Code

xdiff: PATIENCE/HISTOGRAM are not independent option bits
[git.git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22         # do not redirect again
23         ;;
24 *' --tee '*|*' --va'*)
25         mkdir -p test-results
26         BASE=test-results/$(basename "$0" .sh)
27         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28          echo $? > $BASE.exit) | tee $BASE.out
29         test "$(cat $BASE.exit)" = 0
30         exit
31         ;;
32 esac
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
37 # For repeatability, reset the environment to known value.
38 LANG=C
39 LC_ALL=C
40 PAGER=cat
41 TZ=UTC
42 TERM=dumb
43 export LANG LC_ALL PAGER TERM TZ
44 EDITOR=:
45 unset VISUAL
46 unset EMAIL
47 unset $(perl -e '
48         my @env = keys %ENV;
49         my $ok = join("|", qw(
50                 TRACE
51                 DEBUG
52                 USE_LOOKUP
53                 TEST
54                 .*_TEST
55                 PROVE
56                 VALGRIND
57         ));
58         my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
59         print join("\n", @vars);
60 ')
61 GIT_AUTHOR_EMAIL=author@example.com
62 GIT_AUTHOR_NAME='A U Thor'
63 GIT_COMMITTER_EMAIL=committer@example.com
64 GIT_COMMITTER_NAME='C O Mitter'
65 GIT_MERGE_VERBOSITY=5
66 export GIT_MERGE_VERBOSITY
67 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
68 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
69 export EDITOR
71 # Protect ourselves from common misconfiguration to export
72 # CDPATH into the environment
73 unset CDPATH
75 unset GREP_OPTIONS
77 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
78         1|2|true)
79                 echo "* warning: Some tests will not work if GIT_TRACE" \
80                         "is set as to trace on STDERR ! *"
81                 echo "* warning: Please set GIT_TRACE to something" \
82                         "other than 1, 2 or true ! *"
83                 ;;
84 esac
86 # Convenience
87 #
88 # A regexp to match 5 and 40 hexdigits
89 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
90 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
92 # Zero SHA-1
93 _z40=0000000000000000000000000000000000000000
95 # Line feed
96 LF='
97 '
99 # Each test should start with something like this, after copyright notices:
101 # test_description='Description of this test...
102 # This test checks if command xyzzy does the right thing...
103 # '
104 # . ./test-lib.sh
105 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
106                 TERM=$ORIGINAL_TERM &&
107                 export TERM &&
108                 [ -t 1 ] &&
109                 tput bold >/dev/null 2>&1 &&
110                 tput setaf 1 >/dev/null 2>&1 &&
111                 tput sgr0 >/dev/null 2>&1
112         ) &&
113         color=t
115 while test "$#" -ne 0
116 do
117         case "$1" in
118         -d|--d|--de|--deb|--debu|--debug)
119                 debug=t; shift ;;
120         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
121                 immediate=t; shift ;;
122         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
123                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
124         -h|--h|--he|--hel|--help)
125                 help=t; shift ;;
126         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
127                 verbose=t; shift ;;
128         -q|--q|--qu|--qui|--quie|--quiet)
129                 # Ignore --quiet under a TAP::Harness. Saying how many tests
130                 # passed without the ok/not ok details is always an error.
131                 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
132         --with-dashes)
133                 with_dashes=t; shift ;;
134         --no-color)
135                 color=; shift ;;
136         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
137                 valgrind=t; verbose=t; shift ;;
138         --tee)
139                 shift ;; # was handled already
140         --root=*)
141                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
142                 shift ;;
143         *)
144                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
145         esac
146 done
148 if test -n "$color"; then
149         say_color () {
150                 (
151                 TERM=$ORIGINAL_TERM
152                 export TERM
153                 case "$1" in
154                         error) tput bold; tput setaf 1;; # bold red
155                         skip)  tput bold; tput setaf 2;; # bold green
156                         pass)  tput setaf 2;;            # green
157                         info)  tput setaf 3;;            # brown
158                         *) test -n "$quiet" && return;;
159                 esac
160                 shift
161                 printf "%s" "$*"
162                 tput sgr0
163                 echo
164                 )
165         }
166 else
167         say_color() {
168                 test -z "$1" && test -n "$quiet" && return
169                 shift
170                 echo "$*"
171         }
172 fi
174 error () {
175         say_color error "error: $*"
176         GIT_EXIT_OK=t
177         exit 1
180 say () {
181         say_color info "$*"
184 test "${test_description}" != "" ||
185 error "Test script did not set test_description."
187 if test "$help" = "t"
188 then
189         echo "$test_description"
190         exit 0
191 fi
193 exec 5>&1
194 if test "$verbose" = "t"
195 then
196         exec 4>&2 3>&1
197 else
198         exec 4>/dev/null 3>/dev/null
199 fi
201 test_failure=0
202 test_count=0
203 test_fixed=0
204 test_broken=0
205 test_success=0
207 test_external_has_tap=0
209 die () {
210         code=$?
211         if test -n "$GIT_EXIT_OK"
212         then
213                 exit $code
214         else
215                 echo >&5 "FATAL: Unexpected exit with code $code"
216                 exit 1
217         fi
220 GIT_EXIT_OK=
221 trap 'die' EXIT
223 # The semantics of the editor variables are that of invoking
224 # sh -c "$EDITOR \"$@\"" files ...
226 # If our trash directory contains shell metacharacters, they will be
227 # interpreted if we just set $EDITOR directly, so do a little dance with
228 # environment variables to work around this.
230 # In particular, quoting isn't enough, as the path may contain the same quote
231 # that we're using.
232 test_set_editor () {
233         FAKE_EDITOR="$1"
234         export FAKE_EDITOR
235         EDITOR='"$FAKE_EDITOR"'
236         export EDITOR
239 test_decode_color () {
240         awk '
241                 function name(n) {
242                         if (n == 0) return "RESET";
243                         if (n == 1) return "BOLD";
244                         if (n == 30) return "BLACK";
245                         if (n == 31) return "RED";
246                         if (n == 32) return "GREEN";
247                         if (n == 33) return "YELLOW";
248                         if (n == 34) return "BLUE";
249                         if (n == 35) return "MAGENTA";
250                         if (n == 36) return "CYAN";
251                         if (n == 37) return "WHITE";
252                         if (n == 40) return "BLACK";
253                         if (n == 41) return "BRED";
254                         if (n == 42) return "BGREEN";
255                         if (n == 43) return "BYELLOW";
256                         if (n == 44) return "BBLUE";
257                         if (n == 45) return "BMAGENTA";
258                         if (n == 46) return "BCYAN";
259                         if (n == 47) return "BWHITE";
260                 }
261                 {
262                         while (match($0, /\033\[[0-9;]*m/) != 0) {
263                                 printf "%s<", substr($0, 1, RSTART-1);
264                                 codes = substr($0, RSTART+2, RLENGTH-3);
265                                 if (length(codes) == 0)
266                                         printf "%s", name(0)
267                                 else {
268                                         n = split(codes, ary, ";");
269                                         sep = "";
270                                         for (i = 1; i <= n; i++) {
271                                                 printf "%s%s", sep, name(ary[i]);
272                                                 sep = ";"
273                                         }
274                                 }
275                                 printf ">";
276                                 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
277                         }
278                         print
279                 }
280         '
283 nul_to_q () {
284         perl -pe 'y/\000/Q/'
287 q_to_nul () {
288         perl -pe 'y/Q/\000/'
291 q_to_cr () {
292         tr Q '\015'
295 q_to_tab () {
296         tr Q '\011'
299 append_cr () {
300         sed -e 's/$/Q/' | tr Q '\015'
303 remove_cr () {
304         tr '\015' Q | sed -e 's/Q$//'
307 # In some bourne shell implementations, the "unset" builtin returns
308 # nonzero status when a variable to be unset was not set in the first
309 # place.
311 # Use sane_unset when that should not be considered an error.
313 sane_unset () {
314         unset "$@"
315         return 0
318 test_tick () {
319         if test -z "${test_tick+set}"
320         then
321                 test_tick=1112911993
322         else
323                 test_tick=$(($test_tick + 60))
324         fi
325         GIT_COMMITTER_DATE="$test_tick -0700"
326         GIT_AUTHOR_DATE="$test_tick -0700"
327         export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
330 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
332 # This will commit a file with the given contents and the given commit
333 # message.  It will also add a tag with <message> as name.
335 # Both <file> and <contents> default to <message>.
337 test_commit () {
338         file=${2:-"$1.t"}
339         echo "${3-$1}" > "$file" &&
340         git add "$file" &&
341         test_tick &&
342         git commit -m "$1" &&
343         git tag "$1"
346 # Call test_merge with the arguments "<message> <commit>", where <commit>
347 # can be a tag pointing to the commit-to-merge.
349 test_merge () {
350         test_tick &&
351         git merge -m "$1" "$2" &&
352         git tag "$1"
355 # This function helps systems where core.filemode=false is set.
356 # Use it instead of plain 'chmod +x' to set or unset the executable bit
357 # of a file in the working directory and add it to the index.
359 test_chmod () {
360         chmod "$@" &&
361         git update-index --add "--chmod=$@"
364 # Unset a configuration variable, but don't fail if it doesn't exist.
365 test_unconfig () {
366         git config --unset-all "$@"
367         config_status=$?
368         case "$config_status" in
369         5) # ok, nothing to unset
370                 config_status=0
371                 ;;
372         esac
373         return $config_status
376 # Set git config, automatically unsetting it after the test is over.
377 test_config () {
378         test_when_finished "test_unconfig '$1'" &&
379         git config "$@"
382 # Use test_set_prereq to tell that a particular prerequisite is available.
383 # The prerequisite can later be checked for in two ways:
385 # - Explicitly using test_have_prereq.
387 # - Implicitly by specifying the prerequisite tag in the calls to
388 #   test_expect_{success,failure,code}.
390 # The single parameter is the prerequisite tag (a simple word, in all
391 # capital letters by convention).
393 test_set_prereq () {
394         satisfied="$satisfied$1 "
396 satisfied=" "
398 test_have_prereq () {
399         # prerequisites can be concatenated with ','
400         save_IFS=$IFS
401         IFS=,
402         set -- $*
403         IFS=$save_IFS
405         total_prereq=0
406         ok_prereq=0
407         missing_prereq=
409         for prerequisite
410         do
411                 total_prereq=$(($total_prereq + 1))
412                 case $satisfied in
413                 *" $prerequisite "*)
414                         ok_prereq=$(($ok_prereq + 1))
415                         ;;
416                 *)
417                         # Keep a list of missing prerequisites
418                         if test -z "$missing_prereq"
419                         then
420                                 missing_prereq=$prerequisite
421                         else
422                                 missing_prereq="$prerequisite,$missing_prereq"
423                         fi
424                 esac
425         done
427         test $total_prereq = $ok_prereq
430 test_declared_prereq () {
431         case ",$test_prereq," in
432         *,$1,*)
433                 return 0
434                 ;;
435         esac
436         return 1
439 # You are not expected to call test_ok_ and test_failure_ directly, use
440 # the text_expect_* functions instead.
442 test_ok_ () {
443         test_success=$(($test_success + 1))
444         say_color "" "ok $test_count - $@"
447 test_failure_ () {
448         test_failure=$(($test_failure + 1))
449         say_color error "not ok - $test_count $1"
450         shift
451         echo "$@" | sed -e 's/^/#       /'
452         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
455 test_known_broken_ok_ () {
456         test_fixed=$(($test_fixed+1))
457         say_color "" "ok $test_count - $@ # TODO known breakage"
460 test_known_broken_failure_ () {
461         test_broken=$(($test_broken+1))
462         say_color skip "not ok $test_count - $@ # TODO known breakage"
465 test_debug () {
466         test "$debug" = "" || eval "$1"
469 test_eval_ () {
470         # This is a separate function because some tests use
471         # "return" to end a test_expect_success block early.
472         eval >&3 2>&4 "$*"
475 test_run_ () {
476         test_cleanup=:
477         expecting_failure=$2
478         test_eval_ "$1"
479         eval_ret=$?
481         if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
482         then
483                 test_eval_ "$test_cleanup"
484         fi
485         if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
486                 echo ""
487         fi
488         return "$eval_ret"
491 test_skip () {
492         test_count=$(($test_count+1))
493         to_skip=
494         for skp in $GIT_SKIP_TESTS
495         do
496                 case $this_test.$test_count in
497                 $skp)
498                         to_skip=t
499                         break
500                 esac
501         done
502         if test -z "$to_skip" && test -n "$test_prereq" &&
503            ! test_have_prereq "$test_prereq"
504         then
505                 to_skip=t
506         fi
507         case "$to_skip" in
508         t)
509                 of_prereq=
510                 if test "$missing_prereq" != "$test_prereq"
511                 then
512                         of_prereq=" of $test_prereq"
513                 fi
515                 say_color skip >&3 "skipping test: $@"
516                 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
517                 : true
518                 ;;
519         *)
520                 false
521                 ;;
522         esac
525 test_expect_failure () {
526         test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
527         test "$#" = 2 ||
528         error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
529         export test_prereq
530         if ! test_skip "$@"
531         then
532                 say >&3 "checking known breakage: $2"
533                 if test_run_ "$2" expecting_failure
534                 then
535                         test_known_broken_ok_ "$1"
536                 else
537                         test_known_broken_failure_ "$1"
538                 fi
539         fi
540         echo >&3 ""
543 test_expect_success () {
544         test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
545         test "$#" = 2 ||
546         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
547         export test_prereq
548         if ! test_skip "$@"
549         then
550                 say >&3 "expecting success: $2"
551                 if test_run_ "$2"
552                 then
553                         test_ok_ "$1"
554                 else
555                         test_failure_ "$@"
556                 fi
557         fi
558         echo >&3 ""
561 # test_external runs external test scripts that provide continuous
562 # test output about their progress, and succeeds/fails on
563 # zero/non-zero exit code.  It outputs the test output on stdout even
564 # in non-verbose mode, and announces the external script with "# run
565 # <n>: ..." before running it.  When providing relative paths, keep in
566 # mind that all scripts run in "trash directory".
567 # Usage: test_external description command arguments...
568 # Example: test_external 'Perl API' perl ../path/to/test.pl
569 test_external () {
570         test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
571         test "$#" = 3 ||
572         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
573         descr="$1"
574         shift
575         export test_prereq
576         if ! test_skip "$descr" "$@"
577         then
578                 # Announce the script to reduce confusion about the
579                 # test output that follows.
580                 say_color "" "# run $test_count: $descr ($*)"
581                 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
582                 # to be able to use them in script
583                 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
584                 # Run command; redirect its stderr to &4 as in
585                 # test_run_, but keep its stdout on our stdout even in
586                 # non-verbose mode.
587                 "$@" 2>&4
588                 if [ "$?" = 0 ]
589                 then
590                         if test $test_external_has_tap -eq 0; then
591                                 test_ok_ "$descr"
592                         else
593                                 say_color "" "# test_external test $descr was ok"
594                                 test_success=$(($test_success + 1))
595                         fi
596                 else
597                         if test $test_external_has_tap -eq 0; then
598                                 test_failure_ "$descr" "$@"
599                         else
600                                 say_color error "# test_external test $descr failed: $@"
601                                 test_failure=$(($test_failure + 1))
602                         fi
603                 fi
604         fi
607 # Like test_external, but in addition tests that the command generated
608 # no output on stderr.
609 test_external_without_stderr () {
610         # The temporary file has no (and must have no) security
611         # implications.
612         tmp=${TMPDIR:-/tmp}
613         stderr="$tmp/git-external-stderr.$$.tmp"
614         test_external "$@" 4> "$stderr"
615         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
616         descr="no stderr: $1"
617         shift
618         say >&3 "# expecting no stderr from previous command"
619         if [ ! -s "$stderr" ]; then
620                 rm "$stderr"
622                 if test $test_external_has_tap -eq 0; then
623                         test_ok_ "$descr"
624                 else
625                         say_color "" "# test_external_without_stderr test $descr was ok"
626                         test_success=$(($test_success + 1))
627                 fi
628         else
629                 if [ "$verbose" = t ]; then
630                         output=`echo; echo "# Stderr is:"; cat "$stderr"`
631                 else
632                         output=
633                 fi
634                 # rm first in case test_failure exits.
635                 rm "$stderr"
636                 if test $test_external_has_tap -eq 0; then
637                         test_failure_ "$descr" "$@" "$output"
638                 else
639                         say_color error "# test_external_without_stderr test $descr failed: $@: $output"
640                         test_failure=$(($test_failure + 1))
641                 fi
642         fi
645 # debugging-friendly alternatives to "test [-f|-d|-e]"
646 # The commands test the existence or non-existence of $1. $2 can be
647 # given to provide a more precise diagnosis.
648 test_path_is_file () {
649         if ! [ -f "$1" ]
650         then
651                 echo "File $1 doesn't exist. $*"
652                 false
653         fi
656 test_path_is_dir () {
657         if ! [ -d "$1" ]
658         then
659                 echo "Directory $1 doesn't exist. $*"
660                 false
661         fi
664 test_path_is_missing () {
665         if [ -e "$1" ]
666         then
667                 echo "Path exists:"
668                 ls -ld "$1"
669                 if [ $# -ge 1 ]; then
670                         echo "$*"
671                 fi
672                 false
673         fi
676 # test_line_count checks that a file has the number of lines it
677 # ought to. For example:
679 #       test_expect_success 'produce exactly one line of output' '
680 #               do something >output &&
681 #               test_line_count = 1 output
682 #       '
684 # is like "test $(wc -l <output) = 1" except that it passes the
685 # output through when the number of lines is wrong.
687 test_line_count () {
688         if test $# != 3
689         then
690                 error "bug in the test script: not 3 parameters to test_line_count"
691         elif ! test $(wc -l <"$3") "$1" "$2"
692         then
693                 echo "test_line_count: line count for $3 !$1 $2"
694                 cat "$3"
695                 return 1
696         fi
699 # This is not among top-level (test_expect_success | test_expect_failure)
700 # but is a prefix that can be used in the test script, like:
702 #       test_expect_success 'complain and die' '
703 #           do something &&
704 #           do something else &&
705 #           test_must_fail git checkout ../outerspace
706 #       '
708 # Writing this as "! git checkout ../outerspace" is wrong, because
709 # the failure could be due to a segv.  We want a controlled failure.
711 test_must_fail () {
712         "$@"
713         exit_code=$?
714         if test $exit_code = 0; then
715                 echo >&2 "test_must_fail: command succeeded: $*"
716                 return 1
717         elif test $exit_code -gt 129 -a $exit_code -le 192; then
718                 echo >&2 "test_must_fail: died by signal: $*"
719                 return 1
720         elif test $exit_code = 127; then
721                 echo >&2 "test_must_fail: command not found: $*"
722                 return 1
723         fi
724         return 0
727 # Similar to test_must_fail, but tolerates success, too.  This is
728 # meant to be used in contexts like:
730 #       test_expect_success 'some command works without configuration' '
731 #               test_might_fail git config --unset all.configuration &&
732 #               do something
733 #       '
735 # Writing "git config --unset all.configuration || :" would be wrong,
736 # because we want to notice if it fails due to segv.
738 test_might_fail () {
739         "$@"
740         exit_code=$?
741         if test $exit_code -gt 129 -a $exit_code -le 192; then
742                 echo >&2 "test_might_fail: died by signal: $*"
743                 return 1
744         elif test $exit_code = 127; then
745                 echo >&2 "test_might_fail: command not found: $*"
746                 return 1
747         fi
748         return 0
751 # Similar to test_must_fail and test_might_fail, but check that a
752 # given command exited with a given exit code. Meant to be used as:
754 #       test_expect_success 'Merge with d/f conflicts' '
755 #               test_expect_code 1 git merge "merge msg" B master
756 #       '
758 test_expect_code () {
759         want_code=$1
760         shift
761         "$@"
762         exit_code=$?
763         if test $exit_code = $want_code
764         then
765                 return 0
766         fi
768         echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
769         return 1
772 # test_cmp is a helper function to compare actual and expected output.
773 # You can use it like:
775 #       test_expect_success 'foo works' '
776 #               echo expected >expected &&
777 #               foo >actual &&
778 #               test_cmp expected actual
779 #       '
781 # This could be written as either "cmp" or "diff -u", but:
782 # - cmp's output is not nearly as easy to read as diff -u
783 # - not all diff versions understand "-u"
785 test_cmp() {
786         $GIT_TEST_CMP "$@"
789 # This function can be used to schedule some commands to be run
790 # unconditionally at the end of the test to restore sanity:
792 #       test_expect_success 'test core.capslock' '
793 #               git config core.capslock true &&
794 #               test_when_finished "git config --unset core.capslock" &&
795 #               hello world
796 #       '
798 # That would be roughly equivalent to
800 #       test_expect_success 'test core.capslock' '
801 #               git config core.capslock true &&
802 #               hello world
803 #               git config --unset core.capslock
804 #       '
806 # except that the greeting and config --unset must both succeed for
807 # the test to pass.
809 # Note that under --immediate mode, no clean-up is done to help diagnose
810 # what went wrong.
812 test_when_finished () {
813         test_cleanup="{ $*
814                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
817 # Most tests can use the created repository, but some may need to create more.
818 # Usage: test_create_repo <directory>
819 test_create_repo () {
820         test "$#" = 1 ||
821         error "bug in the test script: not 1 parameter to test-create-repo"
822         repo="$1"
823         mkdir -p "$repo"
824         (
825                 cd "$repo" || error "Cannot setup test environment"
826                 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
827                 error "cannot run git init -- have you built things yet?"
828                 mv .git/hooks .git/hooks-disabled
829         ) || exit
832 test_done () {
833         GIT_EXIT_OK=t
835         if test -z "$HARNESS_ACTIVE"; then
836                 test_results_dir="$TEST_DIRECTORY/test-results"
837                 mkdir -p "$test_results_dir"
838                 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
840                 cat >>"$test_results_path" <<-EOF
841                 total $test_count
842                 success $test_success
843                 fixed $test_fixed
844                 broken $test_broken
845                 failed $test_failure
847                 EOF
848         fi
850         if test "$test_fixed" != 0
851         then
852                 say_color pass "# fixed $test_fixed known breakage(s)"
853         fi
854         if test "$test_broken" != 0
855         then
856                 say_color error "# still have $test_broken known breakage(s)"
857                 msg="remaining $(($test_count-$test_broken)) test(s)"
858         else
859                 msg="$test_count test(s)"
860         fi
861         case "$test_failure" in
862         0)
863                 # Maybe print SKIP message
864                 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
866                 if test $test_external_has_tap -eq 0; then
867                         say_color pass "# passed all $msg"
868                         say "1..$test_count$skip_all"
869                 fi
871                 test -d "$remove_trash" &&
872                 cd "$(dirname "$remove_trash")" &&
873                 rm -rf "$(basename "$remove_trash")"
875                 exit 0 ;;
877         *)
878                 if test $test_external_has_tap -eq 0; then
879                         say_color error "# failed $test_failure among $msg"
880                         say "1..$test_count"
881                 fi
883                 exit 1 ;;
885         esac
888 # Test the binaries we have just built.  The tests are kept in
889 # t/ subdirectory and are run in 'trash directory' subdirectory.
890 if test -z "$TEST_DIRECTORY"
891 then
892         # We allow tests to override this, in case they want to run tests
893         # outside of t/, e.g. for running tests on the test library
894         # itself.
895         TEST_DIRECTORY=$(pwd)
896 fi
897 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
899 if test -n "$valgrind"
900 then
901         make_symlink () {
902                 test -h "$2" &&
903                 test "$1" = "$(readlink "$2")" || {
904                         # be super paranoid
905                         if mkdir "$2".lock
906                         then
907                                 rm -f "$2" &&
908                                 ln -s "$1" "$2" &&
909                                 rm -r "$2".lock
910                         else
911                                 while test -d "$2".lock
912                                 do
913                                         say "Waiting for lock on $2."
914                                         sleep 1
915                                 done
916                         fi
917                 }
918         }
920         make_valgrind_symlink () {
921                 # handle only executables, unless they are shell libraries that
922                 # need to be in the exec-path.  We will just use "#!" as a
923                 # guess for a shell-script, since we have no idea what the user
924                 # may have configured as the shell path.
925                 test -x "$1" ||
926                 test "#!" = "$(head -c 2 <"$1")" ||
927                 return;
929                 base=$(basename "$1")
930                 symlink_target=$GIT_BUILD_DIR/$base
931                 # do not override scripts
932                 if test -x "$symlink_target" &&
933                     test ! -d "$symlink_target" &&
934                     test "#!" != "$(head -c 2 < "$symlink_target")"
935                 then
936                         symlink_target=../valgrind.sh
937                 fi
938                 case "$base" in
939                 *.sh|*.perl)
940                         symlink_target=../unprocessed-script
941                 esac
942                 # create the link, or replace it if it is out of date
943                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
944         }
946         # override all git executables in TEST_DIRECTORY/..
947         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
948         mkdir -p "$GIT_VALGRIND"/bin
949         for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
950         do
951                 make_valgrind_symlink $file
952         done
953         # special-case the mergetools loadables
954         make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
955         OLDIFS=$IFS
956         IFS=:
957         for path in $PATH
958         do
959                 ls "$path"/git-* 2> /dev/null |
960                 while read file
961                 do
962                         make_valgrind_symlink "$file"
963                 done
964         done
965         IFS=$OLDIFS
966         PATH=$GIT_VALGRIND/bin:$PATH
967         GIT_EXEC_PATH=$GIT_VALGRIND/bin
968         export GIT_VALGRIND
969 elif test -n "$GIT_TEST_INSTALLED" ; then
970         GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
971         error "Cannot run git from $GIT_TEST_INSTALLED."
972         PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
973         GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
974 else # normal case, use ../bin-wrappers only unless $with_dashes:
975         git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
976         if ! test -x "$git_bin_dir/git" ; then
977                 if test -z "$with_dashes" ; then
978                         say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
979                 fi
980                 with_dashes=t
981         fi
982         PATH="$git_bin_dir:$PATH"
983         GIT_EXEC_PATH=$GIT_BUILD_DIR
984         if test -n "$with_dashes" ; then
985                 PATH="$GIT_BUILD_DIR:$PATH"
986         fi
987 fi
988 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
989 unset GIT_CONFIG
990 GIT_CONFIG_NOSYSTEM=1
991 GIT_ATTR_NOSYSTEM=1
992 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
994 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
996 if test -z "$GIT_TEST_CMP"
997 then
998         if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
999         then
1000                 GIT_TEST_CMP="$DIFF -c"
1001         else
1002                 GIT_TEST_CMP="$DIFF -u"
1003         fi
1004 fi
1006 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
1007 export GITPERLLIB
1008 test -d "$GIT_BUILD_DIR"/templates/blt || {
1009         error "You haven't built things yet, have you?"
1012 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
1013 then
1014         GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
1015         export GITPYTHONLIB
1016         test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
1017                 error "You haven't built git_remote_helpers yet, have you?"
1018         }
1019 fi
1021 if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
1022         echo >&2 'You need to build test-chmtime:'
1023         echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
1024         exit 1
1025 fi
1027 # Test repository
1028 test="trash directory.$(basename "$0" .sh)"
1029 test -n "$root" && test="$root/$test"
1030 case "$test" in
1031 /*) TRASH_DIRECTORY="$test" ;;
1032  *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
1033 esac
1034 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
1035 rm -fr "$test" || {
1036         GIT_EXIT_OK=t
1037         echo >&5 "FATAL: Cannot prepare test area"
1038         exit 1
1041 HOME="$TRASH_DIRECTORY"
1042 export HOME
1044 test_create_repo "$test"
1045 # Use -P to resolve symlinks in our working directory so that the cwd
1046 # in subprocesses like git equals our $PWD (for pathname comparisons).
1047 cd -P "$test" || exit 1
1049 this_test=${0##*/}
1050 this_test=${this_test%%-*}
1051 for skp in $GIT_SKIP_TESTS
1052 do
1053         case "$this_test" in
1054         $skp)
1055                 say_color skip >&3 "skipping test $this_test altogether"
1056                 skip_all="skip all tests in $this_test"
1057                 test_done
1058         esac
1059 done
1061 # Provide an implementation of the 'yes' utility
1062 yes () {
1063         if test $# = 0
1064         then
1065                 y=y
1066         else
1067                 y="$*"
1068         fi
1070         while echo "$y"
1071         do
1072                 :
1073         done
1076 # Fix some commands on Windows
1077 case $(uname -s) in
1078 *MINGW*)
1079         # Windows has its own (incompatible) sort and find
1080         sort () {
1081                 /usr/bin/sort "$@"
1082         }
1083         find () {
1084                 /usr/bin/find "$@"
1085         }
1086         sum () {
1087                 md5sum "$@"
1088         }
1089         # git sees Windows-style pwd
1090         pwd () {
1091                 builtin pwd -W
1092         }
1093         # no POSIX permissions
1094         # backslashes in pathspec are converted to '/'
1095         # exec does not inherit the PID
1096         test_set_prereq MINGW
1097         test_set_prereq SED_STRIPS_CR
1098         ;;
1099 *CYGWIN*)
1100         test_set_prereq POSIXPERM
1101         test_set_prereq EXECKEEPSPID
1102         test_set_prereq NOT_MINGW
1103         test_set_prereq SED_STRIPS_CR
1104         ;;
1105 *)
1106         test_set_prereq POSIXPERM
1107         test_set_prereq BSLASHPSPEC
1108         test_set_prereq EXECKEEPSPID
1109         test_set_prereq NOT_MINGW
1110         ;;
1111 esac
1113 test -z "$NO_PERL" && test_set_prereq PERL
1114 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1115 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
1117 # Can we rely on git's output in the C locale?
1118 if test -n "$GETTEXT_POISON"
1119 then
1120         GIT_GETTEXT_POISON=YesPlease
1121         export GIT_GETTEXT_POISON
1122 else
1123         test_set_prereq C_LOCALE_OUTPUT
1124 fi
1126 # Use this instead of test_cmp to compare files that contain expected and
1127 # actual output from git commands that can be translated.  When running
1128 # under GETTEXT_POISON this pretends that the command produced expected
1129 # results.
1130 test_i18ncmp () {
1131         test -n "$GETTEXT_POISON" || test_cmp "$@"
1134 # Use this instead of "grep expected-string actual" to see if the
1135 # output from a git command that can be translated either contains an
1136 # expected string, or does not contain an unwanted one.  When running
1137 # under GETTEXT_POISON this pretends that the command produced expected
1138 # results.
1139 test_i18ngrep () {
1140         if test -n "$GETTEXT_POISON"
1141         then
1142             : # pretend success
1143         elif test "x!" = "x$1"
1144         then
1145                 shift
1146                 ! grep "$@"
1147         else
1148                 grep "$@"
1149         fi
1152 # test whether the filesystem supports symbolic links
1153 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1154 rm -f y
1156 # When the tests are run as root, permission tests will report that
1157 # things are writable when they shouldn't be.
1158 test -w / || test_set_prereq SANITY